# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/06_fastAIExample.ipynb.

# %% auto 0
__all__ = ['animals_folder_create', 'download_animal_images', 'verify_pics', 'resize_pics', 'data_folder']

# %% ../nbs/06_fastAIExample.ipynb 15
#|code-fold: true
def animals_folder_create(folder_path, animals):
    for i in animals:
        dest = (folder_path/i)
        dest.mkdir(exist_ok=True, parents=True)

# %% ../nbs/06_fastAIExample.ipynb 16
#|code-fold: true
def download_animal_images(folder_path, animals):
    for j in animals:
        print("downloading images for:", j)
        download_images(
            folder_path/j,
            urls=search_images_ddg(f'{j} photo',200),
            n_workers=32
        )

# %% ../nbs/06_fastAIExample.ipynb 17
#|code-fold: true
def verify_pics(folder_path):
    failed = verify_images(get_image_files(folder_path))
    failed.map(Path.unlink)
    print("Number of images failed", len(failed))

# %% ../nbs/06_fastAIExample.ipynb 18
#|code-fold: true
def resize_pics(folder_path, animals):
    for k in animals:
        resize_images(
            folder_path/k,
            max_size=400,
            dest=folder_path/k,
            max_workers=8
        )
        print("resizing images for:", k)

# %% ../nbs/06_fastAIExample.ipynb 19
#|code-fold: true
def data_folder(folder_path):
    if os.path.exists(folder_path):
        print("Folder already exists:", folder_path)
    else:
        
        animals = ('chimpanzee', 'elephant', 'giraffe',
                    'kangaroo','lion','panda','rabbit',
                    'rhino', 'tiger', 'wolf')    
        
        animals_folder_create(folder_path, animals)
        download_animal_images(folder_path, animals)
        verify_pics(folder_path)
        resize_pics(folder_path, animals)
        print("Folder created:", folder_path)
        
